/* gencodeExonSupport.h was originally generated by the autoSql program, which also 
 * generated gencodeExonSupport.c and gencodeExonSupport.sql.  This header links the database and
 * the RAM representation of objects. */

#ifndef GENCODEEXONSUPPORT_H
#define GENCODEEXONSUPPORT_H

#define GENCODEEXONSUPPORT_NUM_COLS 7

extern char *gencodeExonSupportCommaSepFieldNames;

struct gencodeExonSupport
/* GENCODE exon support from other datasets */
    {
    struct gencodeExonSupport *next;  /* Next in singly linked list. */
    char *transcriptId;	/* GENCODE transcript identifier */
    char *seqId;	/* Identifier of sequence supporting transcript */
    char *seqSrc;	/* Source of supporting sequence */
    char *exonId;	/* GENCODE exon identifier (not stable) */
    char *chrom;	/* Chromosome */
    unsigned chromStart;	/* Start position in chromosome */
    unsigned chromEnd;	/* End position in chromosome */
    };

void gencodeExonSupportStaticLoad(char **row, struct gencodeExonSupport *ret);
/* Load a row from gencodeExonSupport table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct gencodeExonSupport *gencodeExonSupportLoad(char **row);
/* Load a gencodeExonSupport from row fetched with select * from gencodeExonSupport
 * from database.  Dispose of this with gencodeExonSupportFree(). */

struct gencodeExonSupport *gencodeExonSupportLoadAll(char *fileName);
/* Load all gencodeExonSupport from whitespace-separated file.
 * Dispose of this with gencodeExonSupportFreeList(). */

struct gencodeExonSupport *gencodeExonSupportLoadAllByChar(char *fileName, char chopper);
/* Load all gencodeExonSupport from chopper separated file.
 * Dispose of this with gencodeExonSupportFreeList(). */

#define gencodeExonSupportLoadAllByTab(a) gencodeExonSupportLoadAllByChar(a, '\t');
/* Load all gencodeExonSupport from tab separated file.
 * Dispose of this with gencodeExonSupportFreeList(). */

struct gencodeExonSupport *gencodeExonSupportCommaIn(char **pS, struct gencodeExonSupport *ret);
/* Create a gencodeExonSupport out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new gencodeExonSupport */

void gencodeExonSupportFree(struct gencodeExonSupport **pEl);
/* Free a single dynamically allocated gencodeExonSupport such as created
 * with gencodeExonSupportLoad(). */

void gencodeExonSupportFreeList(struct gencodeExonSupport **pList);
/* Free a list of dynamically allocated gencodeExonSupport's */

void gencodeExonSupportOutput(struct gencodeExonSupport *el, FILE *f, char sep, char lastSep);
/* Print out gencodeExonSupport.  Separate fields with sep. Follow last field with lastSep. */

#define gencodeExonSupportTabOut(el,f) gencodeExonSupportOutput(el,f,'\t','\n');
/* Print out gencodeExonSupport as a line in a tab-separated file. */

#define gencodeExonSupportCommaOut(el,f) gencodeExonSupportOutput(el,f,',',',');
/* Print out gencodeExonSupport as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* GENCODEEXONSUPPORT_H */

