/* gencodeToPubMed.h was originally generated by the autoSql program, which also 
 * generated gencodeToPubMed.c and gencodeToPubMed.sql.  This header links the database and
 * the RAM representation of objects. */

#ifndef GENCODETOPUBMED_H
#define GENCODETOPUBMED_H

#define GENCODETOPUBMED_NUM_COLS 2

extern char *gencodeToPubMedCommaSepFieldNames;

struct gencodeToPubMed
/* Gencode metadata table of PubMed identifier of published experimental data associated with Gencode Genes */
    {
    struct gencodeToPubMed *next;  /* Next in singly linked list. */
    char *transcriptId;	/* GENCODE transcript identifier */
    int pubMedId;	/* PubMed identifier of supporting literature */
    };

void gencodeToPubMedStaticLoad(char **row, struct gencodeToPubMed *ret);
/* Load a row from gencodeToPubMed table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct gencodeToPubMed *gencodeToPubMedLoad(char **row);
/* Load a gencodeToPubMed from row fetched with select * from gencodeToPubMed
 * from database.  Dispose of this with gencodeToPubMedFree(). */

struct gencodeToPubMed *gencodeToPubMedLoadAll(char *fileName);
/* Load all gencodeToPubMed from whitespace-separated file.
 * Dispose of this with gencodeToPubMedFreeList(). */

struct gencodeToPubMed *gencodeToPubMedLoadAllByChar(char *fileName, char chopper);
/* Load all gencodeToPubMed from chopper separated file.
 * Dispose of this with gencodeToPubMedFreeList(). */

#define gencodeToPubMedLoadAllByTab(a) gencodeToPubMedLoadAllByChar(a, '\t');
/* Load all gencodeToPubMed from tab separated file.
 * Dispose of this with gencodeToPubMedFreeList(). */

struct gencodeToPubMed *gencodeToPubMedCommaIn(char **pS, struct gencodeToPubMed *ret);
/* Create a gencodeToPubMed out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new gencodeToPubMed */

void gencodeToPubMedFree(struct gencodeToPubMed **pEl);
/* Free a single dynamically allocated gencodeToPubMed such as created
 * with gencodeToPubMedLoad(). */

void gencodeToPubMedFreeList(struct gencodeToPubMed **pList);
/* Free a list of dynamically allocated gencodeToPubMed's */

void gencodeToPubMedOutput(struct gencodeToPubMed *el, FILE *f, char sep, char lastSep);
/* Print out gencodeToPubMed.  Separate fields with sep. Follow last field with lastSep. */

#define gencodeToPubMedTabOut(el,f) gencodeToPubMedOutput(el,f,'\t','\n');
/* Print out gencodeToPubMed as a line in a tab-separated file. */

#define gencodeToPubMedCommaOut(el,f) gencodeToPubMedOutput(el,f,',',',');
/* Print out gencodeToPubMed as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* GENCODETOPUBMED_H */

